//
//  ViewController.swift
//  WebViewTest
//
//  Created by MB KWON on 12/2/14.
//  Copyright (c) 2014 UANGEL Corp. All rights reserved.
//

import UIKit

class ViewController: UIViewController, UIWebViewDelegate {
    
    @IBOutlet weak var webView:UIWebView!
    @IBOutlet weak var textfield:UITextField!
    
    var cookieStorage: NSHTTPCookieStorage = {
        return NSHTTPCookieStorage.sharedHTTPCookieStorage()
        }()
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        if webView != nil {
            webView.delegate = self
        }
        
        textfield.text = "http://requestb.in/16e0vi01"
        //cookieStorage.removeCookiesSinceDate(NSDate(timeIntervalSince1970: 0))
        
        if self.navigationController?.viewControllers[0] as UIViewController == self {
            var session_cookie_parameters: NSDictionary = [NSHTTPCookieDomain:"requestb.in",
                NSHTTPCookiePath:"/",
                NSHTTPCookieName:"sessionCookie",
                NSHTTPCookieValue:"token is here"];
            
            var sessionCookie: NSHTTPCookie = NSHTTPCookie(properties: session_cookie_parameters)!
            
            var cookie_parameters: NSDictionary = [NSHTTPCookieDomain:"requestb.in",
                NSHTTPCookiePath:"/",
                NSHTTPCookieName:"nonSessionCookie",
                NSHTTPCookieValue:"cookie is here",
                NSHTTPCookieExpires:NSDate(timeIntervalSinceNow: 120)];
            
            var cookie: NSHTTPCookie = NSHTTPCookie(properties: cookie_parameters)!
            
            cookieStorage.setCookie(sessionCookie)
            cookieStorage.setCookie(cookie)
        }
        
        if let allCookies = cookieStorage.cookies {
            NSLog("http cookie : %@", allCookies)
        }
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func goWebSite() {
        var url = NSURL(string: textfield.text)
        var httpRequest = NSMutableURLRequest(URL: url!)
        
        httpRequest.HTTPShouldHandleCookies = true
        //httpRequest.addValue("test=customCookie", forHTTPHeaderField: "Cookie")
        
        webView.loadRequest(httpRequest)
    }
    
    @IBAction func navigateToNewWebView() {
        self.performSegueWithIdentifier("showNewWebView", sender: nil)
    }
    
    func webView(webView: UIWebView, shouldStartLoadWithRequest request: NSURLRequest, navigationType: UIWebViewNavigationType) -> Bool {
        
        if let allCookies = cookieStorage.cookies {
            NSLog("http cookie : %@", allCookies)
        }
        
        return true;
    }
    
    func webViewDidStartLoad(webView: UIWebView) {
        
        if let allHeaders = webView.request?.allHTTPHeaderFields {
            NSLog("http headers : %@", allHeaders)
        }
    }
}

